#!/usr/bin/wish


package require msgcat
namespace import msgcat::mc

package require BWidget
lappend auto_path . library
package require pane
package require richtext
package require simxml
package require simcss
package require gui
package require tmp
namespace import tmp::*

source library/scrolled_text.tcl


set mcDir [file join [file dirname [info script]] gui/msgs]
msgcat::mcload $mcDir
msgcat::mclocale $env(LANG)

proc SetResource { win } {

  foreach { win } [winfo children $win] {
    set parameters [option get $win paramList {}]
    foreach { param } $parameters {
      $win configure -$param [option get $win $param {}]
    } ;# foreach
    if { [llength [winfo children $win]] > 0 } {
      SetResource $win
    } ;# if
  } ;# foreach
} ;# proc SetResource


#======================================================
#======================================================
set splash .splashScreen
wm iconify .
toplevel $splash
label $splash.label -text "tkXMLive:" -font "fixed 12 bold" -background white
label $splash.status -text "" -font "fixed 10"         -background white -foreground blue
pack $splash.label $splash.status -expand true -fill both -side top

wm withdraw $splash
wm transient $splash .  ;  wm overrideredirect $splash 1

set x [expr [winfo screenwidth  $splash]/2 - [winfo reqwidth  $splash]/2 - [winfo vrootx [winfo parent $splash]]]
set y [expr [winfo screenheight $splash]/2 - [winfo reqheight $splash]/2 - [winfo vrooty [winfo parent $splash]]]
wm geom $splash +$x+$y
wm deiconify $splash
update idletasks
#======================================================
#======================================================



set fileResource "Xresource"
if [file exists $fileResource] {
  if [ catch { option readfile $fileResource startup} err ] {
    gui::msgDebug "error in $fileResource: $err"
  } ;# Read Resource file
} ;# if Resource fule exists



source gui/default.tcl




#======================================================
#======================================================
gui::data set tkXMLiVEversion {tkXMLive (0.1.4)}
wm title . [gui::data get tkXMLiVEversion]
destroy $splash
wm deiconify .
set x 55
set y 50
wm geom . +$x+$y
#======================================================
#======================================================



