package provide gridbox 1.0

namespace eval gridbox {
  variable GRIDDATA    ; array set GRIDDATA     {}

  proc create { widget args } {
    variable GRIDDATA

    set a_args(-data)   ""
    set a_args(-param)  ""
    set a_args(-col)    1
    set a_args(-row)    2
    array set a_args $args

    set frame [frame $widget]
    set widget [eval {canvas $frame.gridbox} $a_args(-param) \
    -yscrollcommand {[list $frame.yscroll set]}]
    scrollbar $frame.yscroll -orient vertical -command [list $widget yview]

    grid $widget $frame.yscroll -sticky news
    grid rowconfigure    $frame 0 -weight 1
    grid columnconfigure $frame 0 -weight 1

    set GRIDDATA($widget,col) $a_args(-col)
    set GRIDDATA($widget,row) $a_args(-row)

    fill $widget $a_args(-data)

    return $widget
  } ;# proc create

  proc fill { widget data } {
    variable GRIDDATA

    set f [frame $widget.f ]
    $widget create window 0 0 -anchor nw -window $f

    for {set y 1} {$y <= $GRIDDATA($widget,col)} {incr y} {
      for {set x 1} {$x <= $GRIDDATA($widget,row)} {incr x} {
        set entr [entry $f.entry$x:$y]
        grid $entr -sticky we -row [expr $y - 1] -col [expr $x - 1]
        gui::msgDebug "$entr || ($x, $y)"
      } ;# for x
    } ;# for y

    set child $f.entry1:1
    #tkwait visibility $child
    set bbox [grid bbox $f 0 0]
    set incr [lindex $bbox 3]
    set width [winfo reqwidth $f]
    set height [winfo reqheight $f]
    $widget config -scrollregion "0 0 $width $height"
    $widget config -yscrollincrement $incr
#    $widget config -width $width -height $height
  } ;# proc fill
} ;# namespace gridbox

