# Set default value for process variable
    set pos 0                  ;# Position search Cursor
    set buffer {}              ;# Buffer for text
    set action {findXMLstart}  ;# Current operation
    set find_start 0           ;# Index for start action
    set find_end   0           ;# Index for end action
    set total_length [string length $source_xml]  ;# Total length XML document
    set nodes_list {}          ;# List of inserted nodes
    set count_nodes 0
    set count_text  0
# Type action:
#   getText
#   findXMLstart
#   findXMLend
#   findCDATAend

set xml [eval {create -file $a_args(-file)} $attribute  ]
# Process parse ======================================
    while {$pos < $total_length } {
      set char [string index $source_xml $pos]
      switch -- $action {
        findXMLstart {
          set pos [string first "<" $source_xml $pos]
          if { $pos == -1 }  { set pos $total_length ; continue }
          incr pos
          set action  findXMLend
        } ;# switch --- findXMLstart

        findCDATAend {
        }

        findXMLend {
          set new_pos [string first ">" $source_xml $pos]
          if { $new_pos == -1 }  { set pos $total_length ; continue }

          set node_info [string range $source_xml [expr $pos] [expr $new_pos - 1]]
          gui::msgDebug "__PARSE: @$node_info@ || [string index $source_xml $pos] || [string index $node_info end]"
          switch -- [string index $source_xml $pos] {
            ? {
              foreach { node_name node_attr } [simxml::parseNode $node_info] { break }
              set node_name [string toupper $node_name]
              lappend xmlPrCommand($xml:$node_name) $node_attr
              gui::msgDebug "COMMAND: $node_name || $node_attr"
              set pos [expr $new_pos]
              set action findXMLstart
              continue
            }
            ! {
              set tag_name {}
              regexp {.([^\s]+)} $node_info -> tag_name
              set tag_name [string toupper $tag_name]
              switch -- $tag_name {
                ENTITY {
                  if [regexp {\w+\s+(\w+)\s+(["'])(.*?)\2>?} $node_info -> en_name {} en_value] {
                    entity $xml set $en_name $en_value
                    gui::msgDebug "ENTITY: $en_name || $en_value"
                  } ;# if regexp true
                }
                -- {
                  if [regexp {!--(.*)--$} $node_info -> comment] {
                    simxml::add $xml [lindex $nodes_list end] {} -type COMMENT -text $comment
                    gui::msgDebug "COMMENT: $comment"
                  } ;# if
                }
              } ;# switch ! TAG NAME
              if { [string match {[CDATA[*} $tag_name] } {
                gui::msgDebug "CDATA: ######################################"
              } ;# match CDATA section
              set pos [expr $new_pos]
              continue
            }
            / {
              gui::msgDebug "CLOSE TAG: [string range $node_info 1 end]"
              set nodes_list [lreplace $nodes_list end end]
              set pos [expr $new_pos + 1]
              set action getText
              continue
            }
          } ;# switch FIRST NODE symbol

          if  { [string equal [string index $node_info end] {/}] } {
              set node_info [string range $node_info 0 end-1]
              foreach { node_name node_attr } [simxml::parseNode $node_info] { break }
              add $xml [lindex $nodes_list end] $node_name \
                                           -attribute $node_attr -type ELEMENT
              gui::msgDebug "ELEMENT : $node_name ($node_attr)"
              incr count_nodes
            } else {
              set node_name [ set node_attr {} ]
              foreach { node_name node_attr } [simxml::parseNode $node_info] { break }
              lappend nodes_list [add $xml \
                      [lindex $nodes_list end] $node_name -attribute $node_attr]
              gui::msgDebug "OPEN TAG: $node_name ($node_attr) \[[join $nodes_list { / }]\]"
              incr count_nodes
          } ;# switch LAST NODE symbol

          set buffer {}
          set pos [expr $new_pos + 1]
          set action getText
          gui::msgDebug "##############"
        } ;# switch --- findXMLend

        getText {
          set new_pos [string first "<" $source_xml $pos]
          if { $new_pos == -1 }  { set pos $total_length ; continue }

          set buffer [string range $source_xml $pos [expr $new_pos - 1]]
          regsub -all {^\n} $buffer "" buffer
          regsub -all {\n$} $buffer "" buffer
          regsub -all {\s+} $buffer " " buffer
          if { [string trim $buffer "\t\n "] != "" } {
            add $xml [lindex $nodes_list end] {} -text $buffer -type TEXT
            gui::msgDebug "TEXT: |$buffer|"
            incr count_text
          } ;# if founded text if not empty

          set pos [expr $new_pos + 1]
          set action findXMLend
        } ;# switch --- getText
      } ;# switch action
    } ;# Main cycle for Parse XML document

    gui::msgDebug "COUNT NODES: $count_nodes\nCOUNT_TEXT: $count_text"
    return $xml

