proc insTag { tag_name args } {
  set widget         [gui::data get currentTextWidget]
  set xml            [widgetData $widget get xml]
  set tag_type       [simxml::dtdTypeTag $xml $tag_name]
  set cur_tag        [Cursor $widget get TAG]
  set cur_tag_type   [simxml::nodeInfo $xml $cur_tag type]
  set cur_index      [$widget index [Cursor $widget get]]
  set paramInsertTag [lindex $args [expr [lsearch $args "-paramInsert"] + 1] ]
  set text_sel       ""
  set tag_extra      ""

  if [string equal $tag_name #PCDATA] {
    set tag_type TEXT
    set tag_name {}
    set text_sel {}
  } ;# if

  if [string equal $tag_name #COMMAND] {
    set tag_type  TEXT
    set tag_name  {}
    set text_sel  {}
    set tag_extra CDATA
  } ;# if

  if { ([string equal $tag_type TEXT]) &&
    ([string equal $text_sel  {} ]) } {
    gui::msgDebug "EMPTY TEXT in TEXT"
  } ;# if

  switch -- $paramInsertTag {
    before -
    after  {
     switch -- $cur_tag_type {
       TEXT {
        set new_tag [simxml::add $xml {} $tag_name -type $tag_type -text $text_sel \
                                  -position [list $paramInsertTag \
                                  [simxml::nodeInfo $xml $cur_tag parent]] \
                                  -extra $tag_extra]
       }
       TAG {
        set new_tag [simxml::add $xml {} $tag_name -type $tag_type -text $text_sel\
                                  -position [list $paramInsertTag $cur_tag] \
                                  -extra $tag_extra]
       }
     } ;# switch
     updateWidget $widget [simxml::nodeInfo $xml $new_tag parent]
     # FAST update
     #updateWidget $widget $new_tag
     set type empty
     if { [string equal $tag_type TEXT] } {  set type text }
     Cursor $widget set "[lindex [richtext::tagIndex $widget $new_tag -type $type] 0] + 1 chars"
     $widget see insert
    }
    inside {
     switch -- $cur_tag_type {
       TEXT {
        #set cur_start [lindex [$widget tag ranges $cur_tag:text] 0]
        #set cur_end   [lindex [$widget tag ranges $cur_tag:text] 1]
        foreach { cur_start cur_end } [richtext::tagIndex $widget $cur_tag -type text] { break }
        set text_sel  {}

        if {[llength [set cur_sel [selection $widget get index]]] > 0 } {
          # SELECTION
          # BUG!!!! error if selection have any tag inside
          set sel_start  [lindex $cur_sel 0]
          set sel_end    [lindex $cur_sel 1]
          set text_sel   [$widget get $sel_start $sel_end]
          gui::msgDebug "SELECTION: ($text_sel) | $tag_type"
          set text_start [$widget get $cur_start $sel_start ]
          set text_end   [$widget get $sel_end   $cur_end   ]
        } else {
          set text_start [$widget get $cur_start $cur_index ]
          set text_end   [$widget get $cur_index $cur_end   ]
        } ;# if-else SELECTION

        simxml::setParam $xml $cur_tag -text $text_start
        set new_tag [simxml::add $xml {} $tag_name -type $tag_type -text $text_sel \
                              -position [list after $cur_tag] ]
        simxml::add $xml {} {} -type TEXT -text $text_end \
                              -position [list after $new_tag]
        if { ! [string equal $text_sel {}] } {
          simxml::add $xml $new_tag {} -type TEXT -text $text_sel -position {end}
        } ;# if

        if { [string equal $cur_tag_type TEXT] } {
          updateWidget $widget [simxml::nodeInfo $xml $new_tag parent]
        } else {
          # FAST update
          updateWidget $widget $new_tag
        } ;# if-else TEXT tag

        Cursor $widget set $cur_index -no-event true
        $widget see insert
       }
       TAG {
        set new_tag [simxml::add $xml $cur_tag $tag_name \
                                         -type $tag_type ]
        updateWidget $widget $cur_tag
        Cursor $widget set "[lindex [richtext::tagIndex $widget $new_tag -type empty] 0] + 1 chars"
        $widget see insert

       }
      } ;# switch
    }
  } ;# switch $::paramInsertTag

  gui::TreeExpressFill $new_tag
} ;# proc insTag


