proc wRTStatus { action args } {
  set a_args(-font)       fixed
  set a_args(-xml)        {}
  set a_args(-widget)     {}
  set a_args(-name)       {}
  set a_args(-hightlight) {-font-family fixed -underline true}

  switch -- $action {
    create {
      array set a_args [lrange $args 1 end]
      set widget "[lindex $args 0].$a_args(-name)"

      set widgetName  $a_args(-name)       ; unset a_args(-name)
      set fontStyle   $a_args(-font)       ; unset a_args(-font)
      set fontLight   $a_args(-hightlight) ; unset a_args(-hightlight)
      set xmlDocument $a_args(-xml)        ; unset a_args(-xml)
      set rtWidget    $a_args(-widget)     ; unset a_args(-widget)

        set widgetCode {
          proc wRTStatus:%NAME { node } {
            set nodes [simxml::listNodePath [richtext::widgetData %RICHTEXT get xml] \
                                [richtext::Cursor %RICHTEXT get TAG] -verbose true \
                                -expanded true]
            %CANVAS delete all
            #%CANVAS create text 5 3 -text $text -anchor nw -font {%FONT}
            set x 5 ; set y 2 ; set step 2 ; set x_rect 3 ; set y_rect 8
            foreach { nInfo } $nodes {
              if { [string equal [lindex $nInfo 0] {}] } { continue }
              set t  [%CANVAS create text $x $y -text [lindex $nInfo 0] -font {%FONT} \
                                               -anchor nw -tag [lindex $nInfo 1]]
              set x [expr [lindex [%CANVAS bbox $t] 2] + $step ]
              set x1 [expr [lindex [%CANVAS bbox $t] 2] + $step + $x_rect]

              set t1 [%CANVAS create rect $x 4 $x1 $y_rect -fill blue]
              set x [expr [lindex [%CANVAS bbox $t1] 2] + $step + 2 ]

              %CANVAS bind $t <Button-1> {
                set wNode [%W find closest %x %y]
                set wXML  [lindex [%W gettags $wNode] 0]
                richtext::selection %RICHTEXT set -node $wXML
              } ;# bind Button-1

              %CANVAS bind $t <Double-Button-1> {
                set wNode [%W find closest %x %y]
                set wXML  [lindex [%W gettags $wNode] 0]
                richtext::Cursor %RICHTEXT set \
                       "[lindex [richtext::tagIndex %RICHTEXT  $wXML -type open] 0] \
                       + 1 chars"
                richtext::selection %RICHTEXT set -node $wXML
              } ;# bind Button-1

              %CANVAS bind $t <Enter> {
                set xml   [richtext::widgetData %RICHTEXT get xml]
                set wNode [%W find closest %x %y]
                set wXML  [lindex [%W gettags $wNode] 0]
                set attr  [simxml::attribute $xml get $wXML -verbose true]
                %CANVAS itemconfigure $wXML -font {%HIGHTLIGHT}
                %CANVAS config -cursor hand2
                if { ! [string equal $attr {}] } {
                  after 1000 [list gui::balloon %W show "Attribute:$attr" \
                              mousepointer %X [expr [winfo rooty %W] - [winfo height %W] - 10 ]]
                } ;# if $attr != ""
              } ;# bind Enter

              %CANVAS bind $t <Leave> {
                set wNode [%W find closest %x %y]
                set wXML  [lindex [%W gettags $wNode] 0]
                %CANVAS itemconfigure $wXML -font {%FONT}
                %CANVAS config -cursor left_ptr
                catch { destroy %W.balloon }
              } ;# bind Leave
            } ;# foreach
            catch { %CANVAS delete $t1 }
          }
        } ;# set widgetCode

      regsub -all {%NAME}       $widgetCode $widgetName    widgetCode
      regsub -all {%CANVAS}     $widgetCode $widget        widgetCode
      regsub -all {%FONT}       $widgetCode $fontStyle     widgetCode
      regsub -all {%RICHTEXT}   $widgetCode $rtWidget      widgetCode
      regsub -all {%HIGHTLIGHT} $widgetCode $fontLight     widgetCode

      eval $widgetCode
      eval canvas $widget [array get a_args] -height 10

      return $widget
    } ;# create
  } ;# switch action
} ;# proc wRTStatus
