  proc updateWidget { widget xml_node args } {
    variable tagCollapse
    variable IMAGE
    set a_args(-index) {}
    array set a_args $args

    set css        [widgetData $widget get css]
    set xml        [widgetData $widget get xml]
    set xml_root   [widgetData $widget get xml_root]
    set show_tag   [widgetData $widget get show-tag]

    if { [string equal $xml_root ""] } {  set xml_root    [simxml::root get $xml] } ;# if (xml_root eq "")
    if { [string equal $xml_node ""] } {  set xml_node    $xml_root  } ;# if (xml_node eq "")
    if { $xml_node == $xml_root      } {  set node_index  1.0 } ;# if NODE is ROOT

  if { ![string equal $a_args(-index) {}] } {
    set node_index $a_args(-index)
  } else {
    # BUG tag may be ELEMENT
    set open_tag_index  [lindex [tagIndex $widget $xml_node -type open ] 0]
    set close_tag_index [lindex [tagIndex $widget $xml_node -type close] 1]
    if { [llength $open_tag_index] != 0 } {
      set open_tag_index  [$widget index $open_tag_index ]
      set close_tag_index [$widget index $close_tag_index]
      set node_index  [$widget index [lindex $open_tag_index 0]]
      gui::msgDebug "$open_tag_index|$close_tag_index"
      foreach { type mark_name mark_index } [$widget dump -mark $open_tag_index $close_tag_index]  {
        $widget mark unset $mark_name
      } ;# foreach all MARK
      $widget delete $open_tag_index $close_tag_index
     } else {
      set open_tag_index  [lindex [tagIndex $widget $xml_node -type text ] 0]
      if { [llength $open_tag_index] != 0 } {
        set close_tag_index [lindex [tagIndex $widget $xml_node -type text ] 1]
        gui::msgDebug "THIS IS A TEXT: $open_tag_index | $close_tag_index"

        set open_tag_index  [$widget index $open_tag_index ]
        set close_tag_index [$widget index $close_tag_index]
        set node_index  [$widget index [lindex $open_tag_index 0]]
        foreach { type mark_name mark_index } [$widget dump -mark $open_tag_index $close_tag_index]  {
          $widget mark unset $mark_name
        } ;# foreach all MARK
        $widget delete $open_tag_index $close_tag_index
      } ;# if CHECK TEXT
    } ;# if

# Needed check before printed tag
    if { ! [info exists node_index] } {
      set par_child [simxml::nodeInfo $xml [simxml::nodeInfo $xml $xml_node parent] children]
      if { ([set child_index [lsearch $par_child $xml_node ] ] != -1) &&
           ($child_index != 0) } {
        set before_tag [ lindex $par_child [expr $child_index - 1] ]
        set close_before_index [lindex [tagIndex $widget $before_tag -type close ] 1]
        set node_index [$widget index $close_before_index]
        # BUG !!!! need more coding
      } ;# if-else
    } ;# if


    if { ! [info exists node_index] } {
      gui::msgDebug "ERROR: $xml_node ([simxml::nodeInfo $xml $xml_node name]) $open_tag_index"
    } ;# if

  } ;# if-else  -index exists

    set indentTag    [llength [simxml::listNodePath $xml $xml_node -only-parent true]]
    set indent_value [expr {[widgetData $widget get auto-indent] * $indentTag}]



    $widget config -cursor watch
    switch -- [simxml::nodeInfo $xml $xml_node type] {
      TAG {
# START TAG RENDER ==================================================
        catch { foreach { key } [array names style] { unset style($key) } }
        array set style [simcss::getStyle $css $xml_node -xml $xml]
        if { $style(display) == "none" } { return $node_index } ;# if DISPLAY is none
        if { $indent_value != 0 } { set style(margin-left) $indent_value }

        set tag tag
        set node_text $style(tag-openTag)

        if { $show_tag == "OFF" } { set node_text "" }
        switch -- $style(display) {
          block {
            if { [$widget compare $node_index != "$node_index linestart"] } {
              set node_text "\n$node_text"
            } ;# if
          }
          list-item {
            set node_text "* "
            if {  [lsearch -exact $style(list-style) inside]  != -1 } { set style(margin-left) [expr $style(margin-left) + 15] } ;# if LIST-STYLE
            if { ([lsearch -exact $style(list-style) decimal] != -1) || \
                 ([lsearch -exact $style(list-style-type) decimal] != -1) } {
              set node_text "[expr [lsearch -exact \
                                     [simxml::getNodes $xml \
                                     [simxml::nodeInfo $xml $xml_node parent] \
                                     name [simxml::nodeInfo $xml $xml_node name] \
                                     -one-level-child true] \
                                     $xml_node] \
                             + 1]. "
            } ;# if LIST-STYLE
            if { [$widget compare $node_index != "$node_index linestart"] } {
              set node_text "\n$node_text"
            } ;# if
          }
        } ;# switch $style(display)

        catch { set node_text "$node_text$style(content-before)" }

        if { [string length $node_text] == 0 } {
          set node_text " "
          set tag emptyTag
        } ;# if length $node_text == 0

        set old_index $node_index
        set node_index [insNode $widget $node_index \
                                ${xml_node} \
                                $node_text -tag $tag -type open]
        if { [regexp {^(\s*<)(.+?)(\s+)(.+?)/?>\s*$} $node_text -> space1 first_word space2 attr] } {
          set attrStart [expr [string length $space1] + [string length $first_word] + [string length $space2]]
          set attrEnd   [expr $attrStart + [string length $attr]]
          $widget tag add tagAttr "$old_index + $attrStart chars" "$old_index + $attrEnd chars"
        } ;# if

        $widget tag add indent$indentTag $old_index $node_index
        eval $widget tag configure $xml_node:Style \
                                     -rmargin  $style(margin-right) \
                                     -lmargin1 $style(margin-left) \
                                     -lmargin2 $style(margin-left) \
                                     -spacing1 $style(margin-top) \
                                     -spacing3 $style(margin-bottom) \
                                     -justify  $style(text-align)
        $widget tag add $xml_node:Style $old_index $node_index

# _[simxml::nodeInfo $xml $xml_node name]

# DO RECURSE IF NEEDED
        set node_children  [simxml::nodeInfo $xml $xml_node children]
        if { [llength $node_children] > 0 } {
          foreach { children } $node_children {
            set node_index [updateWidget $widget $children -index $node_index]
          } ;# foreach RECURSE
        } else {
# OTHERWISE CHECK FOR EMPTY TEXT IN TAG
          set text_font_style  [simcss::getFontStyle [array get style] -param true -for text]
          set text_tag_style   [simcss::getTagStyle [array get style] -param true -for text]
          eval {$widget tag configure $xml_node:empty} -font {$text_font_style} \
                                                       $text_tag_style \
                                                       -bgstipple gray12 \
                                                       -background $style(color)
          set node_index [insNode $widget $node_index ${xml_node} "   " \
                                  -tag $xml_node:empty -type empty]
        } ;# if have children node

# END TAG RENDER ==================================================
        set tag tag
        set node_text $style(tag-closeTag)
        if { $show_tag == "OFF" } { set node_text "" }
        switch -- $style(display) {
          block {
            if { [$widget compare $node_index != "$node_index linestart"] } {
              set node_text "$node_text\n"
            } ;# if
          }
          list-item {
            set node_text " "
          }
        } ;# switch

        catch { set node_text "$style(content-after)$node_text" }

        if { [string equal $node_text {}] } {
          set node_text " "
          set tag       emptyTag
        } ;# if

        set old_index  $node_index
        set node_index [insNode $widget $node_index \
                                ${xml_node} \
                                $node_text -tag $tag -type close]
# _[simxml::nodeInfo $xml $xml_node name]
        $widget tag add indent$indentTag $old_index $node_index
      }
      ELEMENT {
        array set style [simcss::getStyle $css $xml_node -xml $xml]
        if { $style(display) == "none" } { return $node_index } ;# if DISPLAY is none
        if { $indent_value != 0 }        { set style(margin-left) $indent_value }


        if { [info exists style(image)] } {
          set fileName  [file join [file dirname [simxml::xmlInfo $xml get file]] \
                        [simxml::attribute $xml get $xml_node -name $style(image)]]
          if { [file isfile $fileName] } {
            set image     [image create photo -file $fileName]
          } else {
            set image     [image create photo -data $IMAGE(notFound)]
          } ;# if IMAGE exists

          set old_index  $node_index
          set node_index [insNode $widget $node_index ${xml_node} \
                                          $image -tag {} -type image]
          if { $style(display) == "block" } {
            $widget tag add indent$indentTag $old_index $node_index
            eval $widget tag configure $xml_node:Style \
                                         -rmargin  $style(margin-right) \
                                         -lmargin1 $style(margin-left) \
                                         -lmargin2 $style(margin-left) \
                                         -spacing1 $style(margin-top) \
                                         -spacing3 $style(margin-bottom) \
                                         -justify  $style(text-align)
            $widget tag add $xml_node:Style "$old_index linestart" $node_index
            $widget tag raise $xml_node:Style
          } ;# if $style(display) == block
          return $node_index
        } ;# if EXISTS IMAGE attribute

        if { $show_tag == "OFF" } { set node_text {} }
        set node_text $style(tag-elementTag)
        set tag tag
        switch -- $style(display) {
          block {
            if { [$widget compare $node_index != "$node_index linestart"] } {
              set node_text "\n$node_text\n"
            } ;# if
          }
        } ;# switch

        if { [string equal $node_text {}] } {
          if { $style(display) == "inline" } {
            set node_text " "
          } else {
            set node_text "\n"
          }
          set tag emptyTag
        } ;# if

        set old_index  $node_index
        set node_index [insNode $widget $node_index \
                                ${xml_node} \
                                $node_text -tag $tag -type element]
        $widget tag add indent$indentTag $old_index $node_index
        if { [regexp {^(\s*<)(.+?)(\s+)(.+?)/?>\s*$} $node_text -> space1 first_word space2 attr] } {
          set attrStart [expr [string length $space1] + [string length $first_word] + [string length $space2]]
          set attrEnd   [expr $attrStart + [string length $attr]]
          $widget tag add tagAttr "$old_index + $attrStart chars" "$old_index + $attrEnd chars"
        } ;# if
      }
      TEXT {
        array set style [simcss::getStyle $css [simxml::nodeInfo $xml $xml_node parent] -xml $xml]
        if { $style(display) == "none" } { return $node_index } ;# if DISPLAY is none
        if { $indent_value != 0 } { set style(margin-left) $indent_value }
        if { $style(list-style) == "inside" } {
          set style(margin-left) [expr $style(margin-left) + 15]
        } ;# if LIST-STYLE

        set font_style  [simcss::getFontStyle [array get style] -param true \
                               -for text -fontSize [widgetData $widget get fontSize]]
        set tag_style   [simcss::getTagStyle [array get style] -param true -for text]

if { 1 == 1 } {
          set lmargin2 $style(margin-left);
          if { $style(text-indent) != "NULL" } {
            set lmargin1 [expr $style(margin-left) + $style(text-indent)]
          } ;# if text-indent
          eval $widget tag configure $xml_node:Style \
                                      -rmargin  $style(margin-right) \
                                      -lmargin1 $style(margin-left) \
                                      -lmargin2 $lmargin2 \
                                      -spacing1 $style(margin-top) \
                                      -spacing3 $style(margin-bottom) \
                                      -justify  $style(text-align)
} ;# if COMMENT
        set node_text [simxml::nodeInfo $xml $xml_node text]
        if { [string equal $node_text {}] } {
          set node_text "   "
          set TAG $xml_node:empty
          eval {$widget tag configure $TAG} -font {$font_style} $tag_style -bgstipple gray12 -background $style(color)
          $widget tag raise $TAG
        } else {
          set TAG $xml_node:text
          #set TAG $style(styleName)
          eval {$widget tag configure $TAG} -font {$font_style} $tag_style
          #set TAG [simcss::getStyleName $css $widget $style(styleName) $font_style $tag_style]
          $widget tag raise $TAG
        } ;# if-else

        set old_node_index $node_index
        set node_index [insNode $widget $node_index $xml_node $node_text -tag $TAG -type text]
#        $widget tag add $xml_node:Style "$old_node_index linestart" "$node_index lineend"
#        $widget tag raise $xml_node:Style
      }
    } ;# switch NODE TYPE

    $widget tag raise sel
    $widget config -cursor xterm
    return $node_index
  } ;# proc updateWidget

