package provide richtext 1.0

namespace eval richtext {
  variable ID
  variable BIND         ;  array set BIND        {}
  variable SysFunction  ;  array set SysFunction {}
  variable widgetData   ;  array set widgetData  {}
  variable tagCollapse  ;  array set tagCollapse {}
  variable IMAGE        ;  array set IMAGE       {}

  namespace export xml_add create Set_Style widget_pos

    set IMAGE(notFound) " \
R0lGODdhQABAAOMAAD09PSsrKwAAAICAgNXV1f/////j4/9ycv85Of8AAP+qqv+Ojv/Hx/8d \
Hf9VVf///ywAAAAAQABAAAAE/hCESau9OOuNpfhgKI5kaZ7kJHBs625rsA50bd94ru98LauB \
AWFILBqPyKRySRj8fsKCdEqtWq/YbLb5nBG04LAYy415x+j01mkOftVweBkYjdvHc+j7zl93 \
3X2BV3lngoZShICHhol1i4GNe498kZOQbHSSlnGVm3ednpyYeqF2oKVpp6h4o4WraKoFBgcI \
CbYIBwZYs7W3ubu0tgm4ulSqCsLJtgpWyMrCzFXOzwnRiK2KUtPUCQtU29TeU+DP4gWgBskI \
DLILycXpwuvt71Lxt+wG7sLFoPsJDaocEHZAyr+AVAbaKljgoECC1/44WuCgQTdpwhwYrHjx \
W8aN5hbNaft4DpsjLQoTaASTciVKkrGaJWOnZRvNLDYjtjl5JaVKlslcYvHpMqY9B0G1GEBK \
chdTW0KNFrDYFAtVqGCu/jRmUtMUnyJ7JgtrBawVo1fJWkkbhu3ZrliSiZEbhu5biV6l2NWy \
N0vfKVJfDYJ7xYFhoVkOI8aimAxhK3+vRIYszDHeuJXrZgYz2ejkKp+pdH4sTYFpMaZPh0lt \
rUpgwa5Jw9byerbOTLbD1La9e3Zv2L8FB381fFVxVMdLJQ+13FMkJtCjSzdisof169hz/HnB \
vTsHMyjCix+PQgX58+jFB4gAADs="

  proc widgetData { widget action name args } {
    variable widgetData
    # Standard Data:
    #  * css
    #  * xml
    #  * xml_root
    #  * auto-indent
    #  * show-tag (AUTO | OFF) default AUTO
    #  * fontSize (-n, 0, +n)
    #  * textModify (0 | 1)

    switch -- $action {
      set {
        set widgetData($widget:$name) [lindex $args 0]
      } ;# switch -- set
      get {
        if { [info exists widgetData($widget:$name)] } {
          return $widgetData($widget:$name)
        } else {
          return -code error -errorinfo "Can't found Widget Data '$name' in '$widget'.\n"
        } ;# if-else (Data present)
      } ;# switch -- get
    } ;# switch (action)
  } ;# proc widgetData


# proc updateWidget
source library/richtext-updatewidget.tcl

# proc insTag
source library/richtext-instag.tcl

  proc selection { widget action args } {
    set a_args(-node) {}
    catch { array set a_args $args }
    switch -- $action {
      set {
        if { ! [string equal $a_args(-node) {}] } {
          set start [lindex [tagIndex $widget $a_args(-node) -type open  ] 0]
          set end   [lindex [tagIndex $widget $a_args(-node) -type close ] 1]
        } else {
          foreach { start end } $args { break }
        } ;# if
        $widget tag remove sel 1.0 end
        $widget tag add sel $start $end
      }
      get {
        switch -- [lindex $args 0] {
          index { return [$widget tag ranges sel] }
        } ;# switch GET - _type_
      }
    } ;# switch ACTION
  } ;# proc selection

  proc canDeleteText { widget start end args } {
    set c_open [set c_close [set count 0]]
    foreach { mark value index } [$widget dump -tag $start $end] {
      if { [regexp {.*:open$}  $value] } { incr count    ; incr c_open  }
      if { [regexp {.*:close$} $value] } { incr count -1 ; incr c_close }
    } ;# foreach
    if { [expr $c_open  / 2] == [expr int($c_open  / 2)] } { return 0 }
    if { [expr $c_close / 2] == [expr int($c_close / 2)] } { return 0 }
    return $count
  } ;# proc canDeleteText


  proc textDelete { widget start end args } {
    variable SysFunction
    set a_args(-update)   false
    array set a_args $args

    set xml        [widgetData $widget get xml]

    if { [string equal $a_args(-update) {true}] } {
    foreach { mark value index } [$widget dump -window $start $end] {
      regexp {(.*):[close|open|element]} $value {} widget_tag
      set node [simxml::getNodes $xml {} widget $widget_tag]
      if { $node != {} } {
        simxml::setParam $xml $node -widget {}
      } ;# if
    } ;# foreach
    $widget delete $start $end

# NEED DELETE TAG info from XML Structure
    } else {
      # Can we delete or not?
      if { [canDeleteText $widget $start $end] != 0 } {
        # BUG: Need raise event for ErrorTextDelete
        return -code error -errorcode 10 -errorinfo "Can't Delete Text from $start to $end in $widget\n"
      } ;# if

      set text_tag  {}
      set node_tag  {}
      set empty_sel 0

      foreach { type_key value_key index_key } [$widget dump -all $start $end] {
        switch -- $type_key {
          tagon {
            if [regexp {(.*?):(open|element)}  $value_key  -> node_tag node_type_tag] {
                  if [simxml::isNodeExists $xml $node_tag] {
                  gui::msgDebug "(type=$node_type_tag); $node_tag [simxml::nodeInfo $xml $node_tag name] text=[simxml::nodeInfo $xml $node_tag text]"
                    simxml::del $xml $node_tag
                  } ;# if node exists
                  continue
            } ;# if needed tag is TAG (open || elements)
          } ;# switch --- tagon && tagoff
        } ;# switch type_key
      } ;# foreach DUMP all from START to END

      if { $empty_sel == 0 } {
        set node_tag  [$widget tag names $start]
        set text_pos  [lsearch $node_tag *:text]
        set text_tag  [$widget tag ranges [lindex $node_tag $text_pos]]
        set start_tag [lindex $text_tag 0]
        set end_tag   [lindex $text_tag 1]
        if { [regexp {(.*):text$} [lindex $node_tag $text_pos] {} text_node] && \
            ![string equal $text_node {}]} {
          simxml::setParam $xml $text_node -text "[$widget get $start_tag $start][$widget get $end $end_tag]"
        } ;# if
      } else {
        $widget delete $start $end
        simxml::nodeTextConcatenate $xml 2
        catch {
# BUG
#          updateWidget $widget [widgetData $widget get xml_root]
          updateWidget $widget 2
        } ;# catch
        Cursor $widget set $start
      } ;# if-else empty selection from tag
    }  ;# if DELETE or UPDATE widget
  } ;# proc textDelete


  proc createWidget { args } {
    variable SysFunction

    set a_args(-text)   {}
    array set a_args $args
    set xml     $a_args(-xml)
    set css     $a_args(-css)
    set widget  $a_args(-widget)
    set tag     $a_args(-tag)
    set typeTag $a_args(-typeTag)
    set text    $a_args(-text)
    set ID      $a_args(-id)

    set css_text [simcss::getCSS $css $tag -get "tag-${typeTag}Tag" -xml $xml]
    set css_font [simcss::getCSS $css $tag -get tag-font -xml $xml]
    set name_widget "${widget}.tag:$ID:$typeTag"
    set new_widget [label $name_widget \
                          -text "$css_text" \
                          -font "$css_font" \
                          -background "[simcss::getParam $css $tag tag-background  -xml $xml]" \
                          -foreground "[simcss::getParam $css $tag tag-color -xml $xml]"]

    bind $new_widget <1>        $SysFunction($widget:bindWidgetClick)
    bind $new_widget <Double-1> $SysFunction($widget:bindWidgetDoubleClick)

    return $new_widget
  } ;# proc createWidget


  proc widget_pos { widget found_widget } {
    foreach {key win tmp} [eval {$widget dump -window 1.0 end}] {
      if {[string equal $win $found_widget]} { return [lindex $tmp 0] }
    }
    return {}
  } ;# proc widget_pos


  proc Get_Source { widget } {
    variable tmp {}
    foreach {key value index} [$widget dump  1.0 end] {
      append tmp "$index: key=$key; value=$value\n"
    }
    return $tmp
  } ;# proc Get_Source


  proc insNode { widget index node title args } {
    set a_args(-type) {}
    set a_args(-tag)  {}
    array set a_args $args

    set type $a_args(-type)
    switch -- $type {
      image {
        $widget image create $index -image $title
        $widget mark set tag:$node:element $index
        return "$index + 1 chars"
      }
    } ;# switch $type
    $widget insert $index $title $a_args(-tag)
    $widget mark set tag:$node:$type $index
    if { [string equal $type text] } {  $widget mark gravity tag:$node:$type left  }

    set index [$widget index "$index + [string length $title] chars"]
    return $index
  } ;# proc insTag


  proc nextTag { widget index } {
    set tag_id [ set node_type {} ]
    set after  [$widget mark next $index]
    while { (![regexp {^tag:([^:]+):([^:]+)$} $after -> tag_id node_type]) &&
            (![string equal $after {}]) } {
      set after [$widget mark next $after]
    } ;# while
    return [list $after $tag_id $node_type]
  } ;# proc nextTag

  proc previousTag { widget index } {
    set tag_id [ set node_type {} ]
    set before [$widget mark previous $index]
    while { ! [regexp {^tag:([^:]+):([^:]+)$} $before -> tag_id node_type] } {
      set before [$widget mark previous $before]
    } ;# while before
    return [list $before $tag_id $node_type]
  } ;# proc currentTag

  proc tagIndex { widget node args } {
    set a_args(-type) ""
    set a_args(-xml)  ""
    array set a_args $args

    set curTag tag:$node:$a_args(-type)
    if { [catch {$widget index $curTag}] } {
      return {}
    } else {
      set nextTag [lindex [nextTag $widget $curTag] 0]
    }
    if { [string equal $nextTag {}] } { set nextTag end }
    return [list $curTag $nextTag]
  } ;# proc tagIndex

  proc create { widget args } {
    variable ID
    variable SysFunction

    set a_args(-wrap) word
    set a_args(-widget) text
    array set a_args $args

    if { ![info exists ID] } { set ID 0 }

    set wName $a_args(-widget) ; unset a_args(-widget)
    set widget [eval "text $widget.$wName" [array get a_args]]
    pack $widget -side left -fill both -expand true

# EXTERNAL SOURCE
# BUG!!!!!!!!!!!!!!!!!!!! path to library
    source library/richtext-bind.tcl

    setSysEvent     $widget
    setSysFunction  $widget

    $widget tag configure sel -borderwidth 1 -foreground black -background #EEEEEE

    widgetData $widget set xml         {}
    widgetData $widget set css         {}
    widgetData $widget set auto-indent 0
    widgetData $widget set show-tag    AUTO
    widgetData $widget set fontSize    0
    widgetData $widget set textModify  0

    $widget tag configure hightlightBorder -borderwidth 1 -relief solid
    $widget tag configure tag -foreground gray50 -font {{Courier New} 11}
    $widget tag configure emptyTag -foreground white -font {Arial 1}
    $widget tag configure tagAttr -foreground #00a0a0 -font {{Ciurier New} 11}
    foreach { indent } [list 0 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15] {
      set res [expr $indent * 10]
      $widget tag configure indent$indent -lmargin1 $res -lmargin2 $res
    } ;# foreach INDENT

    return $widget
  } ;# proc create


  proc setSysEvent { widget } {
  # after <<TextChange>> --- Update XML Tree data
if { 1 != 1 } {
    Bind $widget after <<TextChange>> {
        set cursor     [Cursor %W get]
        set tags       [%W tag names $cursor]
        set pos        [lsearch $tags *:text]
        set text_tag   [%W tag ranges [lindex $tags $pos]]
        set start_tag  [lindex $text_tag 0]
        set end_tag    [lindex $text_tag 1]
        set text_node  {}
        regexp {(.*):text$} [lindex $tags $pos] {} text_node
# UPDATE XML Text Tag
        if {![string equal $text_node {}]} {
        # Cursor in first TEXT Tag position ??
          if { [%W compare $cursor != $start_tag] } {
            simxml::setParam [widgetData %W get xml] $text_node -text [%W get $start_tag $end_tag]
          } else {
            simxml::setParam [widgetData %W get xml] $text_node -text [%W get "$cursor - 1 char" $end_tag]
            %W tag add [lindex $tags $pos] "$cursor - 1 char" $end_tag
          } ;# if-else Cursor in first TEXT Tag position
        } else {
        # CURSOR in end text:tag position. Need update text:TAG in widget
          set text_node  {}
          set tags       [%W tag names "$cursor - 2 char"]
          set pos        [lsearch $tags *:text]
          set text_tag   [%W tag ranges [lindex $tags $pos]]
          set start_tag  [lindex $text_tag 0]
          regexp {(.*):text$} [lindex $tags $pos] {} text_node
          if { ![string equal $text_node {}] } {
            %W tag add [lindex $tags $pos] $start_tag $cursor
            set xml     [widgetData %W get xml]
            if [simxml::isNodeExists $xml $text_node] {
              simxml::setParam  $xml $text_node -text "[%W get $start_tag $cursor]"
              #continue
            } ;# if node exists
            # NEED UPDATE XML tree
          } ;# if
        } ;# if-else
    } ;# Bind after <<TextChange>>
} ;# IF COMMENT

  } ;# proc setSysEvent


  proc setSysFunction { widget } {
  variable SysFunction
  # BUG !!!!!!!!!!!!! EMPTY SET System function
    foreach { typeFunction } [list {:system} {}] {
      set SysFunction($widget:createWidget$typeFunction) \
                      "createWidget"
      set SysFunction($widget:bindWidgetClick$typeFunction) ""
      set SysFunction($widget:bindWidgetDoubleClick$typeFunction) ""
    } ;# foreach (systemFunction)
  } ;# proc setSysFunction


  proc Bind { widget event sequence args } {
    variable BIND
# BIND: KeyPress

# ERORR 'event' attribute
    if { ![string equal $event before] == ![string equal $event after] } {
      return -code error -errorinfo "'$event' is not avaliable for Bind.\n"
    } ;#

    if { ![string equal $args {}] } {
      lappend BIND($widget:$sequence:$event) [lindex $args 0]
    } else {
      if { ![info exists BIND($widget:$sequence:$event)] } {
        return -code error -errorinfo "Not found script for sequence '$sequence'.\n"
      } else {
        return $BIND($widget:$sequence:$event)
      } ;# if
    } ;# if
  } ;# proc bind

  proc eventAfter { widget sequence args} {
    variable BIND

    if { [info exists BIND($widget:$sequence:after)] } {
      foreach { command } $BIND($widget:$sequence:after) {
        foreach { param value } $args {
          regsub -all $param $command $value command
        } ;# foreach
        uplevel $command
      } ;# foreach
    } ;#if
  } ;# proc eventAfter


  proc eventBefore { widget sequence args} {
    variable BIND

    if { [info exists BIND($widget:$sequence:before)] } {
      foreach { command } $BIND($widget:$sequence:before) {
        foreach { param value } $args {
          regsub -all $param $command $value command
        } ;# foreach
        uplevel $command
      } ;# foreach
    } ;#if
  } ;# proc eventBefore


  proc Cursor { widget action args } {

    set cur_index {}
    set xml       [widgetData $widget get xml]

    if { [string equal $action "set"] && (![string equal [lindex $args 0] "TAG"]) } {
      if { ![string match *-no-event $args] } {
        eval $widget mark set insert {[lindex $args 0]}
        event generate $widget {<<CursorMove>>}  -root $widget
      } else {
        eval $widget mark set insert {[lindex $args 0]}
      } ;# if
      return
    } ;# if (action eq "set")

# GET Cursor position (default)
    if { [string equal $args {}] } {
      switch -- $action {
        get {
              set cur_index insert
        } ;# get
      } ;# switch

# IF needed get Tag ID in Cursor position
    } elseif { [string equal [lindex $args 0] {TAG}] } {
      switch -- $action {
        get {
          return [lindex [previousTag $widget insert] 1]
          return $xml_node
        } ;# get
        set {
          set xml_node [lindex $args 1]
          #set xml_index [$widget tag ranges "${xml_node}:open"]
          switch -- [simxml::nodeInfo $xml $xml_node type] {
            ELEMENT { set xml_type element }
            TAG     { set xml_type open    }
            TEXT    { set xml_type  text    }
          } ;# switch
          set xml_index [tagIndex $widget $xml_node -type $xml_type]
          if { [llength $xml_index] != 0 } {
            Cursor $widget set [lindex $xml_index 1]
          } ;# if
        }
      } ;# switch
    } ;# if

  return $cur_index
  } ;# proc Cursor


  proc Paste { widget args } {
    set a_args(-text)       {}
    set a_args(-index)      insert
    array set a_args $args


    set a_args(-text) [gui::clipboardGet]

    set cur_tag [previousTag $widget insert]
      switch -- [lindex $cur_tag 2] {
        text    {
          $widget insert $a_args(-index) $a_args(-text)
          updateTag $widget -index $a_args(-index)
        }
        empty   {
          set cur_tag [richtext::previousTag $widget insert]
          set cur_insert [$widget index [lindex $cur_tag 0]]
          set next_tag [richtext::nextTag $widget [lindex $cur_tag 0]]
          if { [string equal $next_tag {}] } { set next_tag end }
          $widget tag delete [lindex $cur_tag 1]:empty
          $widget delete [lindex $cur_tag 0] [lindex $next_tag 0]
          set xml [richtext::widgetData $widget get xml]
          set xml_node [simxml::add $xml [lindex $cur_tag 1] {} -text $a_args(-text) -type TEXT]
          richtext::updateWidget $widget [lindex $cur_tag 1]
          richtext::Cursor $widget set "$cur_insert + [string length $a_args(-text)] chars"
        }
        default { return }
      }; # switch
      richtext::eventAfter  $widget <<CursorMove>> %A "" %W $widget %K ""
  } ;# proc Paste


  proc updateTag { widget args } {
    set a_args(-index) insert
    set a_args(-tag)   [previousTag $widget insert]
    array set a_args $args

    # BUG !!!!!!!!! Esli vyzyvat' ne -index, a -tag
    set cur_tag  $a_args(-tag)
    set next_tag [richtext::nextTag $widget [lindex $cur_tag 0]]

    if { [string equal $next_tag {}] } { set next_tag end }
    simxml::setParam [richtext::widgetData $widget get xml] [lindex $cur_tag 1] \
                     -text [$widget get [lindex $cur_tag 0] [lindex $next_tag 0]]
    # BUG!!!!!!! zestko zavyazan na imeni text TAG pri izmenenii
    #            algoritma budut problemy.
    $widget tag add [lindex $cur_tag 1]:text [lindex $cur_tag 0] [lindex $next_tag 0]

  } ;# proc updateTag

# source for STATUS widget
source library/richtext-status.tcl

}

