proc Scrolled_Text { f args } {
   frame $f
   text $f.txt -font {fixed 10} \
      -xscrollcommand [list Scrolled_Text.set $f.xscroll  [list grid $f.xscroll -row 1 -column 0 -sticky news]] \
      -yscrollcommand [list Scrolled_Text.set $f.yscroll  [list grid $f.yscroll -row 0 -column 1 -sticky news]]
   eval {$f.txt configure} $args
   scrollbar $f.xscroll -orient horizontal -command [list $f.txt xview]
   scrollbar $f.yscroll -orient vertical   -command [list $f.txt yview]

   catch {
     eval $f.xscroll configure [gui::getStyle $::guiXML styleScrollBar]
     eval $f.yscroll configure [gui::getStyle $::guiXML styleScrollBar]
   } ;# catch

   grid $f.txt -sticky news
   ;##
   ;# Only the data should expand, not the scroll bars
   ;#
   grid rowconfigure    $f 0 -weight 1
   grid columnconfigure $f 0 -weight 1

   grid columnconfigure $f 1 -minsize 1
   grid rowconfigure    $f 1 -minsize 1
   return $f.txt
}
#******************************************************#
# Function   : Scroll_set
# Description: callback for the scroll list box, hide
#              scroll bars if they aren't needed
# Author     : Tom Wilkason
# Date       : 6/4/1999
#*******************************************************#
proc Scrolled_Text.set {scrollbar geoCmd offset size} {
   if {$offset != 0.0 || $size != 1.0} {
      eval $geoCmd
      $scrollbar set $offset $size
   } else {
      set manager [lindex $geoCmd 0]
      $manager forget $scrollbar
   } ;# end if
}






