package provide simcss 1.0

namespace eval simcss {
  variable cssDOM
  array set cssDOM   {}
  variable cssCASHE
  array set cssCASHE {}
  variable colorName
  variable ID 0

  proc parseCSS { css text } {
    variable cssDOM
    variable ID

    regsub -all {\n} $text " " text
    regsub -all {/\*.*?\*/} $text {} text
    regsub -all {\s+} $text " " text
    regsub -all "\}" $text "\}\0" text

    foreach { element } [split $text "\0"] {
      set for_nodes [set nodes_param {}]
      regexp -all {^\s*(.*)\{\s*(.*)\}$} $element {} for_nodes nodes_param
      set nodes_param [string trim $nodes_param]

      foreach { node_info }  [split $for_nodes ","] {
        set node_info [string trim $node_info]

        # BUG Need more work with attribute and others!!!!!!!
        foreach { css_param } [split $nodes_param ";"] {
          regexp {([^:]+):(.*)} $css_param {} css_param_key css_param_value
          lappend cssDOM($css:[string toupper $node_info]) \
                              [string trim $css_param_key] \
                              [string trim [string trim $css_param_value] {"}]
          set css_param_key   {}
          set css_param_value {}
        } ;# foreach all css parameter
      } ;# foreach all elements split ','
    } ;# foreach all CSS values
  } ;# proc parseCSS


  proc getAll { css } {
    variable cssDOM

    foreach { key value } [array get cssDOM] {
      append text "$key = \t$value\n"
    } ;# foreach

    return $text
  } ;# proc getAll (for DEBUG)


  proc create { args } {
    variable colorName
    variable cssDOM
    variable ID
    set a_args(-file) {}
    array set a_args $args

    incr ID

    foreach { cName cValue } [list aqua   #00a0a0  blue   #0050ff  fuchsia #ff00a0 \
                                   gray   #a0a0a0  green  #00ff00  lime    #00a000 \
                                   maroon #b00050  navy   #0000a0  olive   #a0a000 \
                                   purple #a000a0  red    #ff0050  silver  #d0d0d0 \
                                   teal   #00a0ff  yellow #ffff00] {
      set colorName($cName) $cValue
    } ;# create color table

    # CHECK windows PLATFORM
    if { $::tcl_platform(platform) == "windows" } {
      set tagFONT 9  ;  set textFONT 10
    } else {
      set tagFONT 10 ;  set textFONT 12
    } ;# if-else tcl_platform
    set cssDOM($ID:_DEFAULT_) [list \
                                tag-openTag              <%N%a> \
                                tag-closeTag             </%N> \
                                tag-elementTag           <%N%a/> \
                                tag-font-family          fixed \
                                tag-font-size            $tagFONT \
                                tag-font-weight          normal \
                                tag-font-style           roman \
                                tag-color                blue \
                                tag-background-color     white \
                                tag-vertical-align       center \
                                tag-display              block \
                                font-family              serif \
                                font-size                $textFONT \
                                font-weight              normal \
                                font-style               roman \
                                text-decoration          none  \
                                color                    black \
                                background-color         white \
                                display                  block \
                                margin-left              0 \
                                margin-left              0 \
                                margin-right             0 \
                                margin-top               0 \
                                margin-bottom            0 \
                                text-align               left \
                                text-indent              NULL \
                                list-style               outside \
                                list-style-type          decimal \
                               ]
;# -slant roman=normal


    if { ! [string equal $a_args(-file) {}] } {
      set FILE [open $a_args(-file) RDONLY]
        parseCSS $ID [read $FILE]
      close $FILE
    } ;# if
    return $ID
  } ;# proc create


  proc getParam { css xml_node param args } {
    variable cssDOM
    set a_args(-xml)  {}
    array set a_args $args

    set xml $a_args(-xml)

    set node [simxml::nodeInfo $xml $xml_node name]

    set need_value {}

# Use standard formating information
    set css_rules [list _DEFAULT_ * $node]
    foreach { css_rule } $css_rules {
      if [info exists cssDOM($css:$css_rule)] {
        set css_info $cssDOM($css:$css_rule)
        foreach { t_param t_value } $css_info {
          if { [string equal $param $t_param] } {
            set need_value $t_value
          } ;# if
        } ;# foreach attribute for current rule
      } ;# if Rule present for this TAG
    } ;# foreach ALL rules

    return $need_value

  } ;# proc getParam


  proc getStyle { css xml_node args } {
    variable cssDOM
    variable cssCASHE
    set a_args(-xml)          {}
    set a_args(-attribute)    {}
    set a_args(-only-one-tag) {false}
    array set a_args $args

    array set style {}
    set upper_attr [set lower_attr {}]

    if { [string equal $a_args(-xml) {}] } {
      set node_name  $xml_node
      set list_nodes $xml_node
      set text_attr  $a_args(-attribute)
      set verbose_path {}
    } else {
      set node_name    [simxml::nodeInfo $a_args(-xml) $xml_node name]
      set list_nodes   [simxml::listNodePath $a_args(-xml) $xml_node -verbose true -only-parent true]
      set verbose_path [simxml::listNodePath $a_args(-xml) $xml_node -for-css true]
      set text_attr    [simxml::nodeInfo $a_args(-xml) $xml_node attribute]
    }

    if { ![string equal $a_args(-only-one-tag) true] } {
# Use standard formating information
    if { (![string equal $verbose_path {}]) && \
         ([info exists cssCASHE($css:$verbose_path)]) } {
      array set style $cssCASHE($css:$verbose_path)
      regsub -all {\s} $verbose_path "|" verbose_path
      set style(styleName) $verbose_path

      # BUG !!! Need change attribute text
# SET property attribute text
      foreach { t_param t_value } $text_attr {
        append upper_attr " [string toupper $t_param]=\"$t_value\""
        append lower_attr " [string tolower $t_param]=\"$t_value\""
      }
      set convert [list "%N" [string toupper $node_name] "%n" [string tolower $node_name] "%a" $lower_attr "%A" $upper_attr]
      foreach { element text } [list tag-openTag <%N%a> tag-closeTag </%N> tag-elementTag <%N%a/>] {
          foreach { param value } $convert { regsub -all $param $text $value text } ;#foreach
          set style($element) $text
      } ;# foreach

      return [array get style]
    } else {
      set css_rules [list _DEFAULT_ *]
      foreach { css_rule } $css_rules {
        if [info exists cssDOM($css:$css_rule)] {
          set css_info $cssDOM($css:$css_rule)
          foreach { t_param t_value } $css_info {
            set t_value [checkAttribute  $t_param $t_value]
            if { ($t_param == "margin-left") && ([info exists style($t_param)]) } {
              set style($t_param) [expr $style($t_param) + $t_value]
            } else {
              set style($t_param) $t_value
            } ;# if
          } ;# foreach attribute for current rule
        } ;# if Rule present for this TAG
      } ;# foreach _DEFAULT_ * rules

#=================================================
      foreach { parent_xml_node } $list_nodes {
        set parent_node $parent_xml_node
        foreach { t_param t_value } [getStyle $css $parent_xml_node -only-one-tag true] {
          if { (![string match "tag-*" $t_param]) && \
               ($t_param != "margin-bottom") && \
               ($t_param != "margin-top") } {
            if { ($t_param == "margin-left") && ([info exists style($t_param)]) } {
              set style($t_param) [expr $style($t_param) + $t_value]
            } else {
              set style($t_param) $t_value
            } ;# if
          } ;# if
        } ;# foreach Style value
      } ;# foreach Parent node

#!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
#      set cssCASHE($css:$verbose_path) [array get style]
    } ;# if
    } ;# if SET -only-one-tag

    #     
    catch { unset style(content-before) }
    catch { unset style(content-after)  }
    catch { unset style(image)          }

    # NORMAL tag
    foreach { css_rule } $node_name {
      if [info exists cssDOM($css:$css_rule)] {
        set css_info $cssDOM($css:$css_rule)
        foreach { t_param t_value } $css_info {
          set t_value [checkAttribute $t_param $t_value]
          if { ($t_param == "margin-left") && ([info exists style($t_param)]) } {
            set style($t_param) [expr $style($t_param) + $t_value]
          } else {
            set style($t_param) $t_value
          } ;# if
        } ;# foreach attribute for current rule
      } ;# if Rule present for this TAG
    } ;# foreach ALL rules


    catch {
      set lParentNode [simxml::listNodePath $a_args(-xml) $xml_node -verbose true -only-parent true]
      set css_sim_rule [ set css_rule $node_name ]
      foreach { parent } [lreverse $lParentNode] {
        # tag > tag > ... > tag
        set css_sim_rule "$parent > $css_sim_rule"
        catch {
          foreach { t_param t_value } $cssDOM($css:$css_sim_rule) {
            set t_value [checkAttribute $t_param $t_value]
            if { ($t_param == "margin-left") && ([info exists style($t_param)]) } {
              set style($t_param) [expr $style($t_param) + $t_value]
            } else {
              set style($t_param) $t_value
            } ;# if
          } ;# foreach attribute for (tag > tag > ... > tag)
        } ;# catch

        # BUG !!!!!!!!    
        # tag tag ... tag
        set css_rule     "$parent $css_rule"
        catch {
          foreach { t_param t_value } $cssDOM($css:$css_rule) {
            set t_value [checkAttribute $t_param $t_value]
            if { ($t_param == "margin-left") && ([info exists style($t_param)]) } {
              set style($t_param) [expr $style($t_param) + $t_value]
            } else {
              set style($t_param) $t_value
            } ;# if
          } ;# foreach attribute for (tag tag ... tag)
        } ;# catch


      } ;# foreach ALL parent tag for current node
    } ;# catch (if true XML)


# SET property attribute text
    foreach { t_param t_value } $text_attr {
      append upper_attr " [string toupper $t_param]=\"$t_value\""
      append lower_attr " [string tolower $t_param]=\"$t_value\""
    }
    set convert [list "%N" [string toupper $node_name] "%n" [string tolower $node_name] "%a" $lower_attr "%A" $upper_attr]
    foreach { element text } [list tag-openTag <%N%a> tag-closeTag </%N> tag-elementTag <%N%a/>] {
        foreach { param value } $convert { regsub -all $param $text $value text } ;#foreach
        set style($element) $text
    } ;# foreach

    set cssCASHE($css:$verbose_path) [array get style]
    catch { unset style({}) }


    return [array get style]
  } ;# proc getStyle

  proc getStyleName { css widget styleName fontStyle tagStyle } {
    variable cssSTYLE
      if { ! [info exists cssSTYLE($css:$styleName)] } {
        set cssSTYLE($css:$styleName) "-font {$fontStyle} $tagStyle"
        eval $widget tag configure $styleName $cssSTYLE($css:$styleName)
      } ;# if
      return $styleName
  } ;# proc getStyleName

  proc getFontStyle { tStyle args } {
    variable cssDOM
    set a_args(-for)      {text}
    set a_args(-param)    {false}
    set a_args(-fontSize) 0
    array set a_args $args

    array set style $tStyle
    if { $a_args(-for)   == "tag"  } { set preffix "tag-" } else { set preffix "" } ;# if
    if { $a_args(-param) == "true" } { set param   "-"    } else { set param   "" } ;# if

    set result {}
    foreach { key name } [list font-family  family \
                               font-size    size \
                               font-weight  weight \
                               font-style   slant] \
                         {
      if { [info exists style($preffix$key)] } {
        if { ($key == "font-size") } {
          if { [regexp {^(\d+)} $style($preffix$key) -> tmp] } {
            set style($preffix$key) $tmp
          } else {
            #BUG !!!!! Need check _DEFAULT_ font-size and increase with (big, bigger, ...)
            set style($preffix$key) 20
          } ;# if font-size
          set style($preffix$key)  [expr $style($preffix$key) + $a_args(-fontSize)]
        }
        lappend result $param$name $style($preffix$key)
      } ;# if
    } ;# foreach all needed key

    switch -- $style(text-decoration) {
      underline {
        lappend result "${param}underline" true
      }
      overline {
        lappend result "${param}overstrike" true
      }
    } ;# switch

    return $result
  } ;# proc getFontStyle


  proc getTagStyle { tStyle args } {
    variable cssDOM
    set a_args(-for)    {text}
    set a_args(-param)  {false}
    array set a_args $args
    array set style $tStyle
    if { $a_args(-for)   == "tag"  } { set preffix "tag-" } else { set preffix "" } ;# if
    if { $a_args(-param) == "true" } { set param   "-"    } else { set param   "" } ;# if

    set result {}
    foreach { key name } [list color             foreground \
                               background-color  background \
                               text-indent       lmargin1 \
                               margin-left       lmargin1 \
                               margin-left       lmargin2 \
                               margin-right      rmargin \
                               margin-top        spacing1 \
                               margin-bottom     spacing3 \
                               text-align        justify \
                               ] \
                         {
      if { [info exists style($preffix$key)] } {
        set style($preffix$key) [checkAttribute $key $style($preffix$key)]
        lappend result $param$name $style($preffix$key)
      } elseif { [info exists style($key)] } {
        switch -- $key {
        text-align    {  set style($preffix$key) $style($key)  }
        text-indent   -
        margin-left   -
        margin-right  -
        margin-top    -
        margin-bottom {
          if { [string equal $style($key) NULL] } {
            set style($preffix$key) $style(margin-left)
          } else {
            regexp {^(\d+)} $style($key) -> tmp
            set style($preffix$key) $tmp
          } ;# if
        }
        } ;# switch
        lappend result $param$name $style($preffix$key)
      };#
    } ;# foreach all needed key

    return $result
  } ;# proc getTagStyle


  proc checkAttribute { name value } {
    variable colorName
    switch -- $name {
      color            -
      background-color {
        if { [string match "rgb*" $value] } {
          if [regexp {(\d+).*?(\d+).*?(\d+)} $value -> red green blue] {
            set value [format "#%02x%02x%02x" $red $green $blue]
            # BUG!!! Need check rgb(100%,0%,35%)
          } ;# if founded color
        } elseif { [info exists colorName($value)] }  {
          set value $colorName($value)
        } ;# if found RGB setting / color Table
      }
      text-indent   -
      margin-left   -
      margin-right  -
      margin-top    -
      margin-bottom {
        regexp {^(\d+)} $value -> value
      }
      text-align {
        if { [string equal [string tolower $value] justify] } { set value left }
      }
    } ;# switch

    return $value
  } ;# proc checkAttribute


  proc lreverse { list } {
    set result {}
    foreach { item } $list {  set result [linsert $result 0 $item]  } ;# foreach
    return $result
  } ;# proc lreverse
}


