<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="html"/>

<xsl:template match="/ARTICLE">
<html>
  <head><title>Article: <xsl:value-of select="/ARTICLE/TITLE"/></title></head>
  <body>
  <xsl:apply-templates/>
  </body>
</html>
</xsl:template>

<xsl:template match="BIBLIOGRAPHY">
  <br/>
  <font size="+1"><xsl:value-of select="TITLE"/></font>
  <xsl:for-each select="BIBLIOENTRY">
    <br/>
    <xsl:value-of select="position()"/>. 
    <xsl:apply-templates select="AUTHORGROUP"/> 
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="TITLE"/>
  </xsl:for-each>
</xsl:template>

<xsl:template match="ARTICLE/TITLE">
  <div align="center">
    <font size="+2" color="#3232C8"><b><xsl:value-of select="."/></b></font>
  </div>
</xsl:template>

<xsl:template match="ARTICLE/AUTHOR">
  <div align="center">
    <b><xsl:value-of select="."/></b>
  </div>
  <br/>
</xsl:template>

<xsl:template match="BIBLIOENTRY/AUTHORGROUP">
  <xsl:for-each select="AUTHOR">
    <xsl:if test="position() > 1">, </xsl:if>
    <xsl:value-of select="."/>
  </xsl:for-each>
</xsl:template>

<xsl:template match="BIBLIOENTRY/TITLE">
  <i><xsl:value-of select="."/></i>
</xsl:template>

<xsl:template match="PARA">
  <p align="justify">
  <xsl:apply-templates/>
  </p>
</xsl:template>

<xsl:template match="LIST">
  <ul>
  <xsl:apply-templates/>
  </ul>
</xsl:template>

<xsl:template match="LIST/ITEM">
  <li><xsl:apply-templates/></li>
</xsl:template>

<xsl:template match="ITEM/SUBITEM">
  <br/><b>- </b><xsl:apply-templates/>
</xsl:template>

<xsl:template match="B">
  <b><xsl:apply-templates/></b>
</xsl:template>

<xsl:template match="IMGTEXT">
  <div align="center"><i><xsl:apply-templates/></i></div>
</xsl:template>
</xsl:stylesheet>
