<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
<xsl:output method="text"/>

<xsl:template match="/ARTICLE">
\documentclass[a4paper,12pt,notitlepage,openany]{article}
\usepackage{latexsym}
\usepackage[T2A]{fontenc}
\usepackage[koi8-r]{inputenc}
\usepackage[russian]{babel}

\title{<xsl:value-of select="TITLE"/>}
\author{<xsl:value-of select="AUTHOR"/>}
\date{<xsl:value-of select="DATE"/>}

\begin{document}
\maketitle
<xsl:apply-templates/>
\end{document}
</xsl:template>

<xsl:template match="/ARTICLE/TITLE"/>
<xsl:template match="/ARTICLE/AUTHOR"/>
<xsl:template match="/ARTICLE/DATE"/>

<xsl:template match="LIST">
\begin{itemize}
  <xsl:apply-templates/>
\end{itemize}
</xsl:template>

<xsl:template match="LIST/ITEM">
\item <xsl:apply-templates/>
</xsl:template>

<xsl:template match="ITEM/SUBITEM">
\begin{itemize}\item <xsl:apply-templates/> \end{itemize}
</xsl:template>

<xsl:template match="B">
\begin{bfseries}<xsl:apply-templates/>\end{bfseries}
</xsl:template>

<xsl:template match="IMGTEXT">
  <div align="center"><i><xsl:apply-templates/></i></div>
</xsl:template>

<xsl:template match="BIBLIOGRAPHY">
\vspace{15mm}
\begin{large}\begin{bfseries}<xsl:value-of select="TITLE"/>\end{bfseries}\end{large}

  <xsl:for-each select="BIBLIOENTRY">
    <xsl:text>
    </xsl:text>
    <xsl:value-of select="position()"/>.<xsl:text> </xsl:text>
    <xsl:apply-templates select="AUTHORGROUP"/>
    <xsl:text> </xsl:text>
    <xsl:apply-templates select="TITLE"/>
    <xsl:text>
    </xsl:text>
  </xsl:for-each>
</xsl:template>

<xsl:template match="BIBLIOENTRY/AUTHORGROUP">
  <xsl:for-each select="AUTHOR">
    <xsl:if test="position() > 1">, </xsl:if>
    <xsl:value-of select="."/>
  </xsl:for-each>
</xsl:template>

<xsl:template match="BIBLIOENTRY/TITLE">
  \begin{itshape}<xsl:value-of select="."/>\end{itshape}
</xsl:template>

<xsl:template match="PARA">
<xsl:text>
</xsl:text>
  <xsl:apply-templates/>
<xsl:text>
</xsl:text>
</xsl:template>

</xsl:stylesheet>
